# -*- coding: utf-8 -*-
from setuphelpers import *

def get_version(app_registry_dict):
    return app_registry_dict['key'].rsplit('-', 1)[-1]


def install():
    bin_name = glob.glob("tryton-*.exe")[0]

    uninstall_older_version()

    install_exe_if_needed(
        bin_name, 
        silentflags="/S",
        key=f"tryton-32bit-{control.get_software_version()}",
        get_version=get_version,
        min_version=control.get_software_version()
    )

def uninstall_older_version():

    killalltasks(ensure_list(control.impacted_process))

    for soft in installed_softwares("Tryton"):
        uninstall_key = soft['key']
        version = soft['key'].rsplit('-', 1)[-1]
        if Version(version) < Version(control.get_software_version()):
            run(uninstall_cmd(uninstall_key))
            wait_uninstallkey_absent(uninstall_key)